Index: java/main/src/main/java/com/framsticks/gui/tree/TreeModel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/TreeModel.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/tree/TreeModel.java	(revision 100)
@@ -1,32 +1,44 @@
 package com.framsticks.gui.tree;
 
-// import java.util.Enumeration;
+import java.util.Enumeration;
 import java.util.Iterator;
 import java.util.LinkedList;
 import java.util.List;
 
+import javax.annotation.Nullable;
 import javax.swing.event.TreeModelEvent;
 import javax.swing.event.TreeModelListener;
 import javax.swing.tree.TreePath;
 
-import org.apache.log4j.Logger;
-
-
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import com.framsticks.core.ListChange;
 import com.framsticks.core.Node;
 import com.framsticks.core.Path;
-import com.framsticks.core.Tree;
 import com.framsticks.core.TreeOperations;
 import com.framsticks.gui.Frame;
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.EventListener;
+import com.framsticks.params.ListAccess;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.Util;
+import com.framsticks.params.ValueParam;
+import com.framsticks.params.types.EventParam;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.Misc;
 import com.framsticks.util.UnsupportedOperationException;
 import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.lang.Casting;
 
+import static com.framsticks.core.TreeOperations.*;
+
 public class TreeModel implements javax.swing.tree.TreeModel {
-	private static final Logger log = Logger.getLogger(TreeModel.class);
+	private static final Logger log = LogManager.getLogger(TreeModel.class);
 
 
 	protected List<TreeModelListener> listeners = new LinkedList<>();
+
 
 	protected final Frame frame;
@@ -45,11 +57,11 @@
 
 	@Override
-	public AbstractNode getChild(Object parent, int number) {
-		return Casting.assertCast(AbstractNode.class, parent).getChild(number);
+	public Object getChild(Object parent, int number) {
+		return Casting.throwCast(AbstractNode.class, parent).getChild(number);
 	}
 
 	@Override
 	public int getChildCount(Object parent) {
-		return Casting.assertCast(AbstractNode.class, parent).getChildCount();
+		return Casting.throwCast(AbstractNode.class, parent).getChildCount();
 	}
 
@@ -59,5 +71,5 @@
 			return -1;
 		}
-		return Casting.assertCast(AbstractNode.class, parent).getIndexOfChild(Casting.assertCast(AbstractNode.class, child));
+		return Casting.throwCast(AbstractNode.class, parent).getIndexOfChild(child);
 	}
 
@@ -69,5 +81,5 @@
 	@Override
 	public boolean isLeaf(Object node) {
-		return Casting.assertCast(AbstractNode.class, node).isLeaf();
+		return Casting.throwCast(AbstractNode.class, node).isLeaf();
 	}
 
@@ -85,5 +97,51 @@
 	protected boolean changing = false;
 
-	public void nodeStructureChanged(TreePath treePath) {
+	public void treeNodesInserted(TreeModelEvent event) {
+		assert frame.isActive();
+		try {
+			for (TreeModelListener listener : listeners) {
+				listener.treeNodesInserted(event);
+			}
+		} catch (ArrayIndexOutOfBoundsException e) {
+		}
+	}
+
+	public void treeNodesRemoved(TreeModelEvent event) {
+		assert frame.isActive();
+		try {
+			for (TreeModelListener listener : listeners) {
+				listener.treeNodesRemoved(event);
+			}
+		} catch (ArrayIndexOutOfBoundsException e) {
+		}
+	}
+
+	public void treeNodesChanged(TreeModelEvent event) {
+		try {
+			for (TreeModelListener listener : listeners) {
+				listener.treeNodesChanged(event);
+			}
+		} catch (ArrayIndexOutOfBoundsException e) {
+		}
+	}
+
+	public TreeModelEvent prepareModelEvent(TreePath treePath, int number, TreeNode node) {
+		return new TreeModelEvent(this, treePath, new int[] {number}, new Object[] { node });
+	}
+
+
+	public TreeModelEvent prepareModelEventRegarding(Access access, String id, TreePath treeListPath) {
+
+		int number = Util.getNumberOfCompositeParamChild(access, access.get(id, Object.class));
+		if (number == -1) {
+			log.debug("encountered minor tree inconsistency in {}", treeListPath);
+			return null;
+		}
+		TreeNode node = Casting.throwCast(TreeNode.class, Casting.throwCast(TreeNode.class, treeListPath.getLastPathComponent()).getChild(number));
+		return prepareModelEvent(treeListPath, number, node);
+	}
+
+	public void treeStructureChanged(TreePath treePath) {
+
 		if (treePath == null) {
 			return;
@@ -92,18 +150,24 @@
 
 		changing = true;
-		log.debug("changing: " + treePath);
-		// Enumeration<TreePath> expanded = frame.jtree.getExpandedDescendants(treePath);
+		log.debug("changing structure: {}", treePath);
+		Enumeration<TreePath> expanded = frame.getJtree().getExpandedDescendants(treePath);
 		TreePath selection = frame.getJtree().getSelectionPath();
 
-		for (TreeModelListener listener : listeners) {
-			listener.treeStructureChanged(new TreeModelEvent(this, treePath));
-		}
-		// if (expanded != null) {
-		// 	while (expanded.hasMoreElements()) {
-		// 		TreePath expansion = expanded.nextElement();
-		// 		// log.info("reexpanding: " + expansion);
-		// 		frame.jtree.expandPath(expansion);
-		// 	}
-		// }
+		try {
+			for (TreeModelListener listener : listeners) {
+				listener.treeStructureChanged(new TreeModelEvent(this, treePath));
+			}
+		} catch (ArrayIndexOutOfBoundsException e) {
+		}
+
+
+		if (expanded != null) {
+			while (expanded.hasMoreElements()) {
+				TreePath expansion = expanded.nextElement();
+				// log.info("reexpanding: {}", expansion);
+				frame.getJtree().expandPath(expansion);
+			}
+		}
+
 		if (selection != null) {
 			frame.getJtree().setSelectionPath(selection);
@@ -112,5 +176,9 @@
 	}
 
-	public Path convertToPath(TreePath treePath) {
+	/**
+	 *
+	 * This method may return null on conversion failure, which may happen in highload situations.
+	 */
+	public @Nullable Path convertToPath(TreePath treePath) {
 		final Object[] components = treePath.getPath();
 		assert components[0] == frame.getRootNode();
@@ -128,5 +196,6 @@
 			Node node = treeNode.tryCreateNode();
 			if (node == null) {
-				throw new FramsticksException().msg("failed to recreate path").arg("treePath", treePath);
+				return null;
+				// throw new FramsticksException().msg("failed to recreate path").arg("treePath", treePath);
 			}
 			nodes.add(node);
@@ -137,5 +206,5 @@
 	}
 
-	public TreePath convertToTreePath(Path path) {
+	public TreePath convertToTreePath(Path path, boolean forceComplete) {
 		assert frame.isActive();
 
@@ -143,17 +212,15 @@
 		accumulator.add(getRoot());
 
-		for (AbstractNode r : getRoot().getChildren()) {
+		for (Object r : getRoot().getChildren()) {
 			if (r instanceof TreeNode) {
 				TreeNode root = (TreeNode) r;
 				if (root.getTree() == path.getTree()) {
+					Iterator<Node> n = path.getNodes().iterator();
+					TreeNode treeNode = root;
 					accumulator.add(root);
-
-					Iterator<Node> i = path.getNodes().iterator();
-					i.next();
-					TreeNode treeNode = root;
-
-					while (i.hasNext()) {
-						Node node = i.next();
-						treeNode = treeNode.getTreeNodeForChild(node.getObject());
+					n.next();
+					while (n.hasNext()) {
+						Node node = n.next();
+						treeNode = treeNode.prepareTreeNodeForChild(Path.build().tree(path.getTree()).buildUpTo(path.getNodes(), node).finish());
 						if (treeNode == null) {
 							break;
@@ -161,5 +228,4 @@
 						accumulator.add(treeNode);
 					}
-
 					break;
 				}
@@ -167,4 +233,11 @@
 		}
 		return new TreePath(accumulator.toArray());
+	}
+
+	/**
+	 * @return the listeners
+	 */
+	public List<TreeModelListener> getListeners() {
+		return listeners;
 	}
 
@@ -180,5 +253,5 @@
 			return;
 		}
-		AccessInterface access = TreeOperations.bindAccess(path);
+		Access access = TreeOperations.bindAccess(path);
 
 		int count = access.getCompositeParamCount();
@@ -193,5 +266,5 @@
 			return;
 		}
-		if (path.isResolved() && !reload) {
+		if (!reload && path.isResolved() && isMarked(path.getTree(), path.getTopObject(), FETCHED_MARK, false)) {
 			return;
 		}
@@ -199,13 +272,16 @@
 			@Override
 			protected void result(Path result) {
-				final TreePath treePath = convertToTreePath(result);
-
-				nodeStructureChanged(treePath);
-				frame.updatePanelIfIsLeadSelection(treePath, result);
+				final TreePath treePath = convertToTreePath(result, true);
+
+
+				if (treePath != null) {
+					treeStructureChanged(treePath);
+					frame.updatePanelIfIsLeadSelection(result);
+				}
 			}
 		});
 	}
 
-	public void chooseTreeNode(final TreePath treePath) {
+	public void expandTreeNode(TreePath treePath) {
 		assert frame.isActive();
 		if (treePath == null) {
@@ -215,15 +291,154 @@
 			return;
 		}
-
 		Path path = convertToPath(treePath);
 		if (path == null) {
 			return;
 		}
+		loadChildren(path.assureResolved(), false);
+	}
+
+	public void chooseTreeNode(final TreePath treePath) {
+		assert frame.isActive();
+		if (treePath == null) {
+			return;
+		}
+		if (isChanging()) {
+			return;
+		}
+
+		Path path = convertToPath(treePath);
+		if (path == null) {
+			return;
+		}
 		path = path.assureResolved();
-		final Tree tree = path.getTree();
-
-		frame.getTreeAtFrames().get(tree).useOrCreatePanel(treePath);
-		loadChildren(path, false);
-
-	}
+
+		log.debug("choosing {}", path);
+		frame.showPanelForTreePath(treePath);
+		loadPath(path, false);
+
+	}
+
+
+	protected void registerForEventParam(final TreeNode treeNode, Path path, final EventParam eventParam, ValueParam valueParam) {
+		/** TODO make this listener not bind hold the reference to this TreeNode, maybe hold WeakReference internally */
+		if (valueParam instanceof PrimitiveParam) {
+
+			treeNode.tryAddListener(path, eventParam, Object.class, new EventListener<Object>() {
+				@Override
+				public void action(Object argument) {
+					loadPath(treeNode.assurePath(), true);
+				}
+			});
+
+		} else if (valueParam instanceof CompositeParam) {
+
+			final CompositeParam compositeParam = (CompositeParam) valueParam;
+
+			treeNode.tryAddListener(path, eventParam, ListChange.class, new EventListener<ListChange>() {
+				@Override
+				public void action(ListChange listChange) {
+					assert treeNode.getTree().isActive();
+
+					Path parentPath = treeNode.assurePath();
+					final Path listPath = parentPath.appendParam(compositeParam).tryFindResolution();
+					if (!listPath.isResolved()) {
+						/** that situation is quietly ignored - it may happen if first event comes before the container was resolved */
+						return;
+					}
+
+					log.debug("reacting to change {} in {}", listChange, listPath);
+					final TreePath treeListPath = convertToTreePath(listPath, true);
+					if (treeListPath == null) {
+						throw new FramsticksException().msg("path was not fully converted").arg("path", listPath);
+					}
+
+					if ((listChange.getAction().equals(ListChange.Action.Modify)) && (listChange.getPosition() == -1)) {
+						// get(listPath, future);
+						// treeModel.nodeStructureChanged(treePath);
+						// frame.updatePanelIfIsLeadSelection(treePath, result);
+						return;
+					}
+					final String id = listChange.getBestIdentifier();
+
+					final ListAccess access = (ListAccess) bindAccess(listPath);
+					switch (listChange.getAction()) {
+						case Add: {
+							Path childPath = listPath.appendParam(access.prepareParamFor(id)).tryFindResolution();
+							if (!childPath.isResolved()) {
+								childPath = create(childPath);
+
+								TreeModelEvent event = prepareModelEventRegarding(access, id, treeListPath);
+								if (event != null) {
+									treeNodesInserted(event);
+								} else {
+									treeStructureChanged(treeListPath);
+								}
+								frame.updatePanelIfIsLeadSelection(listPath);
+							}
+
+							listPath.getTree().get(childPath, new FutureHandler<Path>(frame) {
+								@Override
+								protected void result(Path result) {
+									if (!result.isResolved()) {
+										log.warn("inconsistency after addition list change: {}", result);
+									}
+									assert frame.isActive();
+									final TreePath treePath = Misc.throwIfNull(frame.getTreeModel().convertToTreePath(result, true));
+
+									// treeModel.nodeStructureChanged(treePath);
+									frame.updatePanelIfIsLeadSelection(result);
+
+									log.debug("added {}({}) updated {}", id, result, treePath);
+								}
+							});
+							break;
+						}
+						case Remove: {
+
+							TreeModelEvent event = prepareModelEventRegarding(access, id, treeListPath);
+							access.set(id, null);
+							if (event != null) {
+								treeNodesRemoved(event);
+							} else {
+								treeStructureChanged(treeListPath);
+							}
+
+							frame.updatePanelIfIsLeadSelection(listPath);
+
+							break;
+						}
+						case Modify: {
+							Path childPath = listPath.appendParam(access.prepareParamFor(id)).tryResolveIfNeeded();
+							listPath.getTree().get(childPath, new FutureHandler<Path>(frame) {
+								@Override
+								protected void result(Path result) {
+									assert frame.isActive();
+									// final TreePath treePath = frame.getTreeModel().convertToTreePath(result, true);
+
+									TreeModelEvent event = prepareModelEventRegarding(access, id, treeListPath);
+									if (event != null) {
+										treeNodesChanged(event);
+									} else {
+										treeStructureChanged(treeListPath);
+									}
+
+									frame.updatePanelIfIsLeadSelection(listPath);
+									frame.updatePanelIfIsLeadSelection(result);
+								}
+							});
+							break;
+						}
+					}
+				}
+			});
+		}
+
+	}
+
+
+
+	protected final Object createdTag = new Object();
+
+
+
 }
Index: java/main/src/main/java/com/framsticks/gui/tree/TreeNode.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/TreeNode.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/tree/TreeNode.java	(revision 100)
@@ -5,12 +5,8 @@
 import java.util.LinkedList;
 import java.util.List;
-import java.util.concurrent.atomic.AtomicInteger;
-
-import javax.swing.ImageIcon;
-import javax.swing.tree.TreePath;
-
-import org.apache.log4j.Logger;
-
-import com.framsticks.core.ListChange;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
 import com.framsticks.core.Node;
 import com.framsticks.core.Path;
@@ -19,9 +15,9 @@
 import com.framsticks.gui.ImageProvider;
 import com.framsticks.gui.TreeAtFrame;
-import com.framsticks.params.AccessInterface;
+import com.framsticks.gui.TreePanel;
+import com.framsticks.params.Access;
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.EventListener;
 import com.framsticks.params.FramsClass;
-import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ValueParam;
 import com.framsticks.params.types.EventParam;
@@ -32,39 +28,45 @@
 import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Containers;
-import com.framsticks.util.lang.Pair;
 import com.framsticks.util.swing.TooltipConstructor;
+
 import static com.framsticks.core.TreeOperations.*;
 
 public class TreeNode extends AbstractNode {
-	private static final Logger log = Logger.getLogger(TreeNode.class);
-
-
-	protected static final AtomicInteger counter = new AtomicInteger();
+
+	private static final Logger log = LogManager.getLogger(TreeNode.class);
 
 	protected final WeakReference<Object> reference;
+	protected final int hashCode;
+	protected final TreeAtFrame treeAtFrame;
+	protected final String textual;
 	protected final CompositeParam param;
-	protected final TreeAtFrame treeAtFrame;
-	protected final List<Pair<WeakReference<Object>, WeakReference<TreeNode>>> children = new LinkedList<>();
-	protected final int number;
-	protected final String textualPath;
-	protected final ImageIcon imageIcon;
-	protected final TreeModel treeModel;
-
-	protected final List<EventListener<?>> listeners = new LinkedList<>();
-
+	protected TreePanel panel;
+
+	public TreeModel getTreeModel() {
+		return treeAtFrame.getFrame().getTreeModel();
+	}
+
+	/**
+	 * @param reference
+	 */
 	public TreeNode(TreeAtFrame treeAtFrame, Path path) {
 		path.assureResolved();
-		this.textualPath = path.getTextual();
+
+		this.reference = new WeakReference<Object>(path.getTopObject());
+		this.textual = path.getTextual();
+		this.treeAtFrame = treeAtFrame;
 		this.param = path.getTop().getParam();
-		this.treeAtFrame = treeAtFrame;
-		this.treeModel = treeAtFrame.getFrame().getTreeModel();
-		this.imageIcon = ImageProvider.loadImage(TreeCellRenderer.findIconName(param));
-
-		reference = new WeakReference<Object>(path.getTop().getObject());
-		number = counter.getAndIncrement();
+		hashCode = System.identityHashCode(path.getTopObject());
+
+		if (getTree().getSideNote(path.getTopObject(), getTreeModel().createdTag, Object.class) == getTreeModel().createdTag) {
+			return;
+		}
+
+		// path.getTree().putSideNote(path.getTopObject(), Textual.class, path.getTextual());
+		path.getTree().putSideNote(path.getTopObject(), getTreeModel().createdTag, getTreeModel().createdTag);
 
 		/** Iterate over all EventParams and for matching ValueParams register listeners. */
-		if (param instanceof ObjectParam) {
-			AccessInterface access = bindAccess(path);
+		if (path.getTop().getParam() instanceof ObjectParam) {
+			Access access = bindAccess(path);
 			FramsClass framsClass = access.getFramsClass();
 			for (EventParam eventParam : Containers.filterInstanceof(framsClass.getParamEntries(), EventParam.class)) {
@@ -77,139 +79,20 @@
 					continue;
 				}
-				registerForEventParam(path, eventParam, valueParam);
-			}
-		}
-	}
-
-	protected <A> void tryAddListener(final Path path, final EventParam eventParam, Class<A> argumentType, final EventListener<A> listener) {
-		treeAtFrame.getTree().addListener(path, eventParam, listener, argumentType, new FutureHandler<Void>(treeAtFrame.getFrame()) {
-			@Override
-			protected void result(Void result) {
-				assert treeAtFrame.getFrame().isActive();
-				log.debug("registered gui listener for " + eventParam + " at " + path);
-				listeners.add(listener);
-			}
-		});
-	}
-
-	protected void registerForEventParam(Path path, EventParam eventParam, ValueParam valueParam) {
-		/** TODO make this listener not bind hold the reference to this TreeNode, maybe hold WeakReference internally */
-		if (valueParam instanceof PrimitiveParam) {
-
-			tryAddListener(path, eventParam, Object.class, new EventListener<Object>() {
-				@Override
-				public void action(Object argument) {
-					treeModel.loadPath(assurePath(), true);
-				}
-			});
-
-		} else if (valueParam instanceof CompositeParam) {
-
-			final CompositeParam compositeParam = (CompositeParam) valueParam;
-
-			tryAddListener(path, eventParam, ListChange.class, new EventListener<ListChange>() {
-				@Override
-				public void action(ListChange listChange) {
-					assert treeAtFrame.getTree().isActive();
-
-					final Path listPath = assurePath().appendParam(compositeParam).tryFindResolution().assureResolved();
-					log.debug("reacting to change " + listChange + " in " + listPath);
-
-					if ((listChange.getAction().equals(ListChange.Action.Modify)) && (listChange.getPosition() == -1)) {
-						// get(listPath, future);
-						return;
-					}
-					final String id = listChange.getBestIdentifier();
-
-					AccessInterface access = bindAccess(listPath);
-					switch (listChange.getAction()) {
-						case Add: {
-							tryGet(listPath.getTree(), Path.appendString(listPath.getTextual(), id), new FutureHandler<Path>(treeAtFrame.getFrame()) {
-								@Override
-								protected void result(Path result) {
-									final Frame frame = treeAtFrame.getFrame();
-									assert frame.isActive();
-									final TreePath treePath = frame.getTreeModel().convertToTreePath(listPath);
-									treeModel.nodeStructureChanged(treePath);
-									frame.updatePanelIfIsLeadSelection(treePath, listPath);
-									log.debug("added " + id + "(" + result + ") updated " + treePath);
-								}
-							});
-							break;
-						}
-						case Remove: {
-							access.set(id, null);
-							Frame frame = treeAtFrame.getFrame();
-							treeModel.nodeStructureChanged(frame.getTreeModel().convertToTreePath(listPath));
-							break;
-						}
-						case Modify: {
-							tryGet(listPath.getTree(), Path.appendString(listPath.getTextual(), id), new FutureHandler<Path>(treeAtFrame.getFrame()) {
-								@Override
-								protected void result(Path result) {
-									final Frame frame = treeAtFrame.getFrame();
-									assert frame.isActive();
-									final TreePath treePath = frame.getTreeModel().convertToTreePath(result);
-									treeModel.nodeStructureChanged(treePath);
-									frame.updatePanelIfIsLeadSelection(treePath, listPath);
-								}
-							});
-							break;
-						}
-					}
-				}
-			});
-		}
-
-	}
-
-	protected Path assurePath() {
-		return Path.to(treeAtFrame.getTree(), textualPath).assureResolved();
-	}
-
-	public Node tryCreateNode() {
-		Object child = lock();
-		if (child == null) {
-			return null;
-		}
-		return Path.to(treeAtFrame.getTree(), textualPath).assureResolved().getTop();
-	}
-
-	@Override
-	public int getChildCount() {
-		Object referent = lock();
-		if (referent == null) {
-			return 0;
-		}
-		AccessInterface access = bindAccessFor(referent);
-		final int count = access.getCompositeParamCount();
-		return count;
-	}
-
-	public TreeNode getTreeNodeForChild(Object child) {
-		Iterator<Pair<WeakReference<Object>, WeakReference<TreeNode>>> i = children.iterator();
-		while (i.hasNext()) {
-			Pair<WeakReference<Object>, WeakReference<TreeNode>> p = i.next();
-			Object object = p.first.get();
-			if (object == null) {
-				i.remove();
-				continue;
-			}
-			TreeNode treeNode = p.second.get();
-			if (treeNode == null) {
-				i.remove();
-				continue;
-			}
-			if (object == child) {
-				return treeNode;
-			}
-		}
-		return null;
-
-		// WeakReference<GuiTreeNode> resultReference = children.get(child);
-		// if (resultReference == null) {
-		//	return null;
-		// }
-		// return resultReference.get();
+				getTreeModel().registerForEventParam(this, path, eventParam, valueParam);
+			}
+		}
+	}
+
+	@Override
+	public int hashCode() {
+		return hashCode;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (obj instanceof TreeNode) {
+			return lock() == ((TreeNode) obj).lock();
+		}
+		return false;
 	}
 
@@ -220,5 +103,6 @@
 			throw new FramsticksException().msg("invalid state - missing referent");
 		}
-		AccessInterface access = bindAccessFor(referent);
+		Tree tree = getTree();
+		Access access = bindAccessForTreeObject(referent);
 
 		final int count = access.getCompositeParamCount();
@@ -227,22 +111,33 @@
 		}
 
+		/** textual path may be not valid anymore*/
 		CompositeParam childParam = access.getCompositeParam(number);
-		Object child = access.get(childParam, Object.class);
-		if (child == null) {
-			log.debug("returning dummy node for " + childParam + " in " + referent);
-			return new EmptyNode(childParam);
-		}
-
-		TreeNode result = getTreeNodeForChild(child);
-		if (result != null) {
-			return result;
-		}
-		Path path = Path.to(treeAtFrame.getTree(), Path.appendString(textualPath, childParam.getId())).assureResolved();
-		result = new TreeNode(treeAtFrame, path);
-
-		children.add(Pair.make(new WeakReference<Object>(child), new WeakReference<TreeNode>(result)));
-
-		return result;
-
+
+		try {
+			Path path = Path.to(tree, getTextual()).appendParam(childParam).tryFindResolution();
+			if (!path.isResolved()) {
+				path = create(path);
+			}
+			return prepareTreeNodeForChild(path);
+		} catch (FramsticksException e) {
+		}
+		return new EmptyNode(getFrame(), childParam);
+
+	}
+
+	public TreeNode prepareTreeNodeForChild(Path path) {
+		assert path.getTree() == getTree();
+		Object parent = lock();
+		Iterator<Node> n = path.getNodes().iterator();
+		while (n.hasNext()) {
+			if (n.next().getObject() == parent) {
+				break;
+			}
+		}
+		if (!n.hasNext()) {
+			return null;
+			// throw new FramsticksException().msg("tree node is not on path (or is last)").arg("path", path).arg("node", this);
+		}
+		return new TreeNode(treeAtFrame, path);
 	}
 
@@ -252,5 +147,5 @@
 
 	@Override
-	public int getIndexOfChild(AbstractNode child) {
+	public int getIndexOfChild(Object child) {
 		final TreeNode treeChild = Casting.tryCast(TreeNode.class, child);
 		if (treeChild == null) {
@@ -262,5 +157,5 @@
 			return -1;
 		}
-		final AccessInterface access = bindAccessFor(parentObject);
+		final Access access = bindAccessForTreeObject(parentObject);
 
 		final int count = access.getCompositeParamCount();
@@ -271,30 +166,51 @@
 			}
 		}
-		log.debug(child + " not found in " + this);
+		log.debug("{} not found in {}", child, this);
 		return -1;
 	}
 
-	/**
-	 * @return the param
-	 */
-	public CompositeParam getParam() {
-		return param;
-	}
-
-	/**
-	 * @return the tree
-	 */
+	public Frame getFrame() {
+		return getTreeAtFrame().getFrame();
+	}
+
+	public TreeAtFrame getTreeAtFrame() {
+		return treeAtFrame;
+	}
+
 	public Tree getTree() {
-		return treeAtFrame.getTree();
-	}
-
+		return getTreeAtFrame().getTree();
+	}
+
+	protected Path assurePath() {
+		return Path.to(getTree(), getTextual()).assureResolved();
+	}
 
 	@Override
 	public String toString() {
-		return param.toString();
-	}
-
-	public static Node tryGetNode(TreePath treePath) {
-		return Casting.throwCast(TreeNode.class, treePath.getLastPathComponent()).tryCreateNode();
+		return getTextual();
+	}
+
+	public Node tryCreateNode() {
+		Object child = lock();
+		if (child == null) {
+			return null;
+		}
+		String textual = getTextual();
+		Path path = Path.tryTo(getTree(), textual);
+		if (path.isResolved(textual)) {
+			return path.getTop();
+		}
+		return null;
+	}
+
+	@Override
+	public int getChildCount() {
+		Object referent = lock();
+		if (referent == null) {
+			return 0;
+		}
+		Access access = bindAccessForTreeObject(referent);
+		final int count = access.getCompositeParamCount();
+		return count;
 	}
 
@@ -305,26 +221,32 @@
 			return true;
 		}
-		return bindAccessFor(referent).getCompositeParamCount() == 0;
-	}
-
-	protected AccessInterface bindAccessFor(Object child) {
-		return treeAtFrame.getTree().prepareAccess(param).select(child);
+		return bindAccessForTreeObject(referent).getCompositeParamCount() == 0;
+	}
+
+	protected Access bindAccessForTreeObject(Object child) {
+		return bindAccessFromSideNote(getTree(), child);
 	}
 
 	@Override
 	public void render(TreeCellRenderer renderer) {
+
+		Object child = lock();
+		if (child == null) {
+			renderer.setToolTipText("?");
+			renderer.setText("?");
+			renderer.setIcon(ImageProvider.loadImage(ImageProvider.FOLDER_CLOSED));
+			return;
+		}
+		Access access = bindAccessForTreeObject(child);
+		CompositeParam param = getTree().getSideNote(child, CompositeParam.class, CompositeParam.class);
 		String name = param.getId();
 
-		Object child = lock();
-		if (child != null) {
-			AccessInterface access = bindAccessFor(child);
-
-			StringParam nameParam = Casting.tryCast(StringParam.class, access.getParam("name"));
-
-			if (nameParam != null) {
-				name = access.get(nameParam, String.class);
-			}
-
-			renderer.setToolTipText(new TooltipConstructor()
+		StringParam nameParam = Casting.tryCast(StringParam.class, access.getParam("name"));
+
+		if (nameParam != null) {
+			name = access.get(nameParam, String.class);
+		}
+
+		renderer.setToolTipText(new TooltipConstructor()
 				.append("frams", access.getId())
 				.append("java", child.getClass().getCanonicalName())
@@ -333,16 +255,50 @@
 				.append("id", param.getId())
 				.append("object", Integer.toHexString(System.identityHashCode(child)))
-				.append("number", number)
-				.append("textual path", textualPath)
+				.append("size", access.getCompositeParamCount())
 				.build());
-		} else {
-			renderer.setToolTipText(new TooltipConstructor()
-				.append("param", param)
-				.append("textual path", textualPath)
-				.build());
-		}
+
+		renderer.setIcon(ImageProvider.loadImage(TreeCellRenderer.findIconName(param)));
 		renderer.setText(name);
-		renderer.setIcon(imageIcon);
-
+	}
+
+	// public static class Textual {
+	// }
+
+	public String getTextual() {
+		return textual;
+		// return getTree().getSideNote(lock(), Textual.class, String.class);
+	}
+
+	protected final Object listenersTag = new Object();
+
+	public List<EventListener<?>> getListeners() {
+		@SuppressWarnings("unchecked")
+		List<EventListener<?>> result = getTree().getSideNote(lock(), listenersTag, List.class);
+		if (result == null) {
+			result = new LinkedList<>();
+			getTree().putSideNote(lock(), listenersTag, result);
+		}
+
+		return result;
+	}
+
+	protected <A> void tryAddListener(final Path path, final EventParam eventParam, Class<A> argumentType, final EventListener<A> listener) {
+		getTree().addListener(path, eventParam, listener, argumentType, new FutureHandler<Void>(getFrame()) {
+			@Override
+			protected void result(Void result) {
+				assert getFrame().isActive();
+				log.debug("registered gui listener for {} at {}", eventParam, path);
+				getListeners().add(listener);
+			}
+		});
+	}
+
+	@Override
+	public TreePanel getPanel() {
+		if (panel != null) {
+			return panel;
+		}
+		panel = getTreeAtFrame().preparePanel(param);
+		return panel;
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/windows/ServerLogFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/windows/ServerLogFrame.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/windows/ServerLogFrame.java	(revision 100)
@@ -2,5 +2,5 @@
 
 import com.framsticks.gui.ImageProvider;
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import javax.swing.*;
@@ -85,5 +85,5 @@
 			if (popUp && !this.isVisible())
 				this.setVisible(true);
-			Logger.getLogger(ServerLogFrame.class).error(
+			LogManager.getLogger(ServerLogFrame.class).error(
 					"level " + level + " class " + clazz + " function "
 							+ function + " msg " + message);
Index: java/main/src/main/java/com/framsticks/hosting/Cli.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/Cli.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/hosting/Cli.java	(revision 100)
@@ -4,5 +4,6 @@
 import java.util.TreeMap;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.communication.Response;
@@ -20,5 +21,5 @@
 public class Cli {
 	private static final Logger log =
-		Logger.getLogger(Cli.class);
+		LogManager.getLogger(Cli.class);
 
 
@@ -39,5 +40,5 @@
 
 	public void addListener(Path path, EventParam param, String pathPrefix, ServerSideResponseFuture responseFuture) {
-		log.debug("adding listener for " + path + ": " + param);
+		log.debug("adding listener for {}: {}", path, param);
 
 		final CliEvent event = new CliEvent();
@@ -53,5 +54,5 @@
 			@Override
 			public void action(Object argument) {
-				log.debug("registered event " + event + " happened with " + argument);
+				log.debug("registered event {} happened with {}", event, argument);
 
 				client.connection.sendFile(
Index: java/main/src/main/java/com/framsticks/hosting/CliEvent.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/CliEvent.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/hosting/CliEvent.java	(revision 100)
@@ -56,4 +56,9 @@
 
 	@ParamAnnotation
+	public String getUid() {
+		return id;
+	}
+
+	@ParamAnnotation
 	public String getName() {
 		return id;
